/*!************************************************************************************************
  @file NedCmdSearch.c

  @brief  Ned Command Implementation for Miscellaneous commands

  Copyright 2021 Drew Gislason

  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
  associated documentation files (the "Software"), to deal in the Software without restriction,
  including without limitation the rights to use, copy, modify, merge, publish, distribute,
  sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all copies or
  substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
  NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
  DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

  Commands for search and replace.

*///***********************************************************************************************
#include "NedEditor.h"
#include "NedUndo.h"
#include "NedSettings.h"

// used by Project Search and Replace, and GotoDefinition
struct sNcsFindStats_tag;
typedef bool_t (*pfnNcsFind_t)(const char *szPath, struct sNcsFindStats_tag *pStats);

typedef struct sNcsFindStats_tag
{
  pfnNcsFind_t    pfnNcsFind;     // function to call
  void           *pData;          // any other data needed
  long            numFound;       // total # of occurrences found
  long            inFiles;        // at least 1 occurrence found in this many files
  long            numFiles;       // total # of files searched
} sNcsFindStats_t;

typedef struct
{
  bool_t          fAll;           // user press All in yna
  bool_t          fEsc;           // user pressed ESC
  bool_t          fFound;         // found at least 1 occurance
  long            numReplaced;
} sNcsReplace_t;

static const char szFind[]            = "Find: ";
static const char szReplace[]         = "Replace: ";
static const char szWith[]            = "With: ";
static const char szReplaceWith[]     = "Replace With: ";
static const char szProjectFind[]     = "Project Find: ";
static const char szProjectReplace[]  = "Project Replace: ";
static const char szYna[]             = "yna";
static const char szNcsReplaced[]     = "Replaced %ld items";
static const char szNcsNotFound[]     = "'%s' not found";
static const char szNcsFound[]        = "Found '%s'";
static const char szNcsProjFound[]    = "Searched %ld files. Found %ld occurrence(s) of '%s' in %ld file(s)";
static const char szNcsProjReplaced[] = "Searched %ld files. Replaced %ld item(s) in %ld file(s)";
static const char szNcsProjNotFound[] = "Searched %ld files. '%s' not found";
static const char szAutogenerated[]   = "<<<AUTOGENERATED, DO NOT EDIT>>>\n\n";


/*-------------------------------------------------------------------------------------------------
  Gets the search string an optionsm

  Returns >0 if worked, -1 if user hit ESC
-------------------------------------------------------------------------------------------------*/
static long NcsSearch(const char *szPrompt)
{
  sNedSearch_t     *pSearch = &NedEditor()->sSearch;
  static nedKey_t   aAltKeys[] = { NEDKEY_CTRL_C, NEDKEY_CTRL_A, NEDKEY_CTRL_W, NEDKEY_ALT_V };
  long              ret;
  sNedFile_t       *pClip;
  sNedPoint_t       sPoint;
  long              n;

  // show search options in status bar
  pSearch->options |= NEDSTAT_OPT_IN_SEARCH;

  // get clipboard for Ctrl-V to work
  pClip = NedEditorClipboard(FALSE);
  n = NedFileSize(pClip);
  if(n > 0 && n < NEDCFG_MAX_WIDTH)
  {
    NedPointInit(&sPoint, pClip->pBufHead);
    NedPointMemGet((uint8_t *)pSearch->szPaste, &sPoint, n);
  }

  // get pbPaste data for Alt-V to work
  n = sizeof(pSearch->szPbPaste) - 1;
  if(!NedEditorPbPaste((nedChar_t *)pSearch->szPbPaste, &n))
    *pSearch->szPbPaste = '\0';

  while(1)
  {
    // update the status bar to reflect options
    NedEditorUpdateStatusBar();

    // get a string to find
    ret = NedMsgLineEdit(pSearch->szFind, sizeof(pSearch->szFind) - 1, szPrompt, aAltKeys, pSearch->szPaste);
    if(ret >= 1)
    {
      break;
    }
    else if(ret == -1)
    {
      NedMsgClear();
      break;
    }
    else if(ret <= -2)
    {
      ret = NedMsgLineEditIndex(ret);   // convert to 0-n
      NedAssert(ret < NumElements(aAltKeys));
      switch(aAltKeys[ret])
      {
        case NEDKEY_CTRL_C:
          pSearch->options ^= NEDSTAT_OPT_CASE_SENSITIVE;
        break;
        case NEDKEY_CTRL_A:
          pSearch->options ^= NEDSTAT_OPT_WRAP;
        break;
        case NEDKEY_CTRL_W:
          pSearch->options ^= NEDSTAT_OPT_WHOLE_WORD;
        break;
        case NEDKEY_ALT_V:
          strcpy(pSearch->szFind, pSearch->szPbPaste);
        break;
        default:
        break;
      }
    }
  }
  pSearch->options &= ~NEDSTAT_OPT_IN_SEARCH;
  if(ret != -1)
    strcpy(pSearch->szPaste, pSearch->szFind);
  return ret;
}

/*!------------------------------------------------------------------------------------------------
  Repeat last search

  @ingroup  ned_cmd
  @returns  none
*///-----------------------------------------------------------------------------------------------
void NedCmdSearchAgain(void)
{
  sNedSearch_t       *pSearch       = &NedEditor()->sSearch;

  if(NedPointSearch(NedEditorCursor(), pSearch->szFind, (nedPtSearchOpts_t)pSearch->options))
  {
    NedEditorGotoPoint(NedEditorCursor());
    NedMsgPrintf(szNcsFound, pSearch->szFind);
  }
  else
    NedMsgPrintf(szNcsNotFound, pSearch->szFind);
}

/*!------------------------------------------------------------------------------------------------
  Search backward for string

  @ingroup  ned_cmd
  @returns  none
*///-----------------------------------------------------------------------------------------------
void NedCmdSearchBackward(void)
{
  sNedSearch_t     *pSearch = &NedEditor()->sSearch;
  long              ret;

  pSearch->options |= NEDSTAT_OPT_REVERSE;
  ret = NcsSearch(szFind);
  if(ret > 0)
  {
    NedEditorAddPosHistory();
    NedCmdSearchAgain();
  }
}

/*!------------------------------------------------------------------------------------------------
  Search forward for string

  @ingroup  ned_cmd
  @returns  none
*///-----------------------------------------------------------------------------------------------
void NedCmdSearchForward(void)
{
  sNedSearch_t     *pSearch = &NedEditor()->sSearch;
  long              ret;

  pSearch->options &= ~NEDSTAT_OPT_REVERSE;
  ret = NcsSearch(szFind);
  if(ret > 0)
  {
    NedEditorAddPosHistory();
    NedCmdSearchAgain();
  }
}

/*-------------------------------------------------------------------------------------------------
  Support for both Replace and ProjectReplace.

  With user input, replaces text in the current file with the current search criteria. Cursor may
  be moved. fInSelect will be FALSE upon exit.

  Replace blah with blabitty? (y/n/a)

  Assumes *pReplace is initialized. Returns # of items found and # of items replaced.

  Returns TRUE if user pressed ESC, FALSE if not
-------------------------------------------------------------------------------------------------*/
static bool_t NcsReplace(sNcsReplace_t *pReplace)
{
  sNedSearch_t   *pSearch = &NedEditor()->sSearch;
  sNedFile_t     *pFile   = NedEditorFileCur();
  long            pos;
  nedKey_t        c;

  while(1)
  {
    if(NedPointSearch(&pFile->sCursor, pSearch->szFind, (nedPtSearchOpts_t)pSearch->options))
    {
      pReplace->fFound = TRUE;

      // highlight the found item
      pFile->sSelect = pFile->sCursor;
      NedPointCharAdvance(&pFile->sSelect, strlen(pSearch->szFind));
      pFile->fInSelect = TRUE;
      NedEditorGotoPoint(&pFile->sCursor);

      if(pReplace->fAll)
        c = 'y';
      else
      {
        NedEditorUpdateSmart();
        c = NedMsgChoice(szReplaceWith, pSearch->szReplace, szYna);
      }
      if(c == 'a')
      {
        pReplace->fAll = TRUE;
        c = 'y';
      }
      if(c == NEDKEY_ESC)
      {
        pReplace->fEsc = TRUE;
        break;
      }
      if(c == 'y')
      {
        // Replace the string. Update any bookmarks and positions.
        pFile->fDirty = TRUE;
        ++pReplace->numReplaced;
        pos = NedPointPos(&pFile->sCursor);
        NedEditorPosListAdjustDel(&pFile->sCursor, &pFile->sSelect);
        NedUndoDelBlock(NedEditorUndoList(), &pFile->sCursor, &pFile->sSelect);
        NedEditorPosListAdjustIns(&pFile->sCursor, strlen(pSearch->szReplace));
        NedUndoInsBlock(NedEditorUndoList(), &pFile->sCursor, (uint8_t *)pSearch->szReplace, strlen(pSearch->szReplace));
        NedPointFileGotoPos(&pFile->sCursor, pos + strlen(pSearch->szReplace));
      }
    }
    else
      break;
  }

  pFile->fInSelect = FALSE;
  return pReplace->fEsc;             // user pressed ESC
}

/*!------------------------------------------------------------------------------------------------
  Search and replace in this file. Supports CaseSensitive, WholeWord, Wrap

  @ingroup  ned_cmd
  @returns  none
*///-----------------------------------------------------------------------------------------------
void NedCmdReplace(void)
{
  sNedSearch_t     *pSearch = &NedEditor()->sSearch;
  sNcsReplace_t     sReplace;
  long              ret;

  // find what string?
  ret = NcsSearch(szReplace);
  if(ret <= 0)
  {
    NedMsgPrintf(szNcsReplaced, sReplace.numReplaced);
    return;
  }

  // replace with what string?
  ret = NedMsgLineEdit(pSearch->szReplace, sizeof(pSearch->szReplace) - 1, szWith, NULL, pSearch->szPaste);
  if(ret <= 0)
  {
    NedMsgPrintf(szNcsReplaced, sReplace.numReplaced);
    return;
  }

  // so we can go back
  NedEditorAddPosHistory();

  // search always forward, never wrap
  pSearch->options &= ~(NEDSTAT_OPT_REVERSE | NEDSTAT_OPT_WRAP);

  // replace some/all occurrences of found string
  memset(&sReplace, 0, sizeof(sReplace));
  NcsReplace(&sReplace);

  if(!sReplace.fFound)
    NedMsgPrintf(szNcsNotFound, pSearch->szFind);
  else
  {
    NedEditorFileCur()->fInSelect = FALSE;
    NedEditorGotoPoint(NedEditorCursor());
    NedMsgPrintf(szNcsReplaced, sReplace.numReplaced);
  }
}

/*-------------------------------------------------------------------------------------------------
  Helper to ProjectSearch.

  Searches a file for the string and builds a set of lines in error format.

  Example err file: "test.c:9:3: printf\ntest.c:26:3: printf\ntest.c:27:5: printf\n"

  Returns
-------------------------------------------------------------------------------------------------*/
bool_t NcsProjBuildErrLines(const char *szPath, sNcsFindStats_t *pStats)
{
  sNedSearch_t     *pSearch     = &NedEditor()->sSearch;
  sNedFile_t       *pFileErr    = NedEditorFileErr();
  sNedFile_t       *pFile       = NULL;
  bool_t            fExists     = FALSE;
  long              curPos;
  char             *psz;
  char             *szErrFile;
  long              numFound    = 0L;
  long              txtBufSize  = NedBufMaxLen();
  long              txtLen      = 0L;
  long              curLine;
  long              curCol;
  int               thisLen;
  nedPtSearchOpts_t searchOpts;

  NedLogPrintfEx(NEDLOG_CMD_EDIT, "NcsBuildErrLines(%s)\n", szPath);

  // load the file to search
  pFile = NedEditorFileIsOpen(szPath);
  if(pFile)
  {
    fExists = TRUE;
    curPos = NedPointPos(&pFile->sCursor);
  }
  else
    pFile = NedFileNew(NULL, szPath);

  // bad path or permissions, nothing to do
  if(pFile == NULL)
    return TRUE;

  // search always forward, never wrap
  searchOpts = (pSearch->options & (~(NEDSTAT_OPT_REVERSE | NEDSTAT_OPT_WRAP)));

  // find all occurrences in this file
  psz = szErrFile = malloc(txtBufSize);
  NedAssert(psz);
  while(1)
  {
    if(NedPointSearch(&pFile->sCursor, pSearch->szFind, searchOpts))
    {
      ++numFound;

      // create the errLine, e.g. "test.c:27:16: search string\n"
      curLine = NedPointLineGet(&pFile->sCursor, &curCol);
      thisLen = snprintf(psz, txtBufSize - txtLen, "%s:%ld:%ld: %s\n",
                                        NedFilePath(pFile), curLine, curCol, pSearch->szFind);
      if(thisLen > 0)
      {
        psz[thisLen] = '\0';
        txtLen += thisLen;
        psz    += thisLen;

        // need more allocated space
        if((txtBufSize - txtLen) < NEDCFG_MAX_WIDTH)
        {
          txtBufSize += NedBufMaxLen();
          szErrFile = realloc(szErrFile, txtBufSize);
          NedAssert(szErrFile);
          psz = &szErrFile[txtLen];
        }
      }
    }

    // no more found this file
    else
      break;
  }

  if(szErrFile)
  {
    if(numFound > 0)
    {
      pStats->inFiles  += 1;
      pStats->numFound += numFound;
      NedPointFileBottom(&pFileErr->sCursor);
      NedPointInsBlock(&pFileErr->sCursor, (void *)szErrFile, strlen(szErrFile));
    }
    free(szErrFile);
  }

  // done searching, free the file
  if(pFile)
  {
    if(fExists)
      NedPointFileGotoPos(&pFile->sCursor, curPos);
    else
      NedFileFree(NULL, pFile);
  }

  return TRUE;
}

/*-------------------------------------------------------------------------------------------------
  Used to recursively search through a file folder. Adds lines to the editor error file and
  updates stats for each found occurrence from Editor search string. Only looks in files that are
  found in the supported languages.
-------------------------------------------------------------------------------------------------*/
bool_t NcsProjSearchRecursive(unsigned level, char *szPath, sNcsFindStats_t *pStats)
{
  void                 *hList;
  unsigned              numFiles;
  unsigned              i;
  bool_t                fContinue = TRUE;

  NedLogPrintfEx(NEDLOG_CMD_EDIT, "RECURSE: NcsProjSearchRecursive(%s, numFound %ld, inFiles %ld\n",
                 szPath, pStats->numFound, pStats->inFiles);
  // NedLogPrintf("RECURSE: NcsProjSearchRecursive(%s, numFound %ld, inFiles %ld\n",
  //                szPath, pStats->numFound, pStats->inFiles);

  hList = NedFileListNew(szPath);
  if(NedFileIsList(hList))
  {
    // search through file list for pattern
    numFiles = NedFileListLen(hList);
    for(i=0; i<numFiles; ++i)
    {
      // append name to path
      strcpy(szPath, NedFileListGetName(hList, i));
      (void)level;
      NedLogPrintfEx(NEDLOG_CMD_EDIT, "  %u:%u) szPath %s\n", level, i, szPath);

      // recurse into file folders
      if(NedStrLastChar(szPath) == '/')
      {
        NedStrAppendName(szPath, "*");
        fContinue = NcsProjSearchRecursive(level + 1, szPath, pStats);
        if(!fContinue)
          break;
      }

      // found a file
      else
      {
        // count total files, not just those we care about
        ++pStats->numFiles;

        // only pay attention to known file types
        if(NedLangGetNoDef(szPath) != NULL)
        {
          // perform some function on this file
          NedAssert(pStats->pfnNcsFind);
          fContinue = (pStats->pfnNcsFind)(szPath, pStats);
          if(!fContinue)
            break;
        }
      }
    }

    // done with file list
    NedFileListFree(hList);
  }

  return fContinue;
}

/*-------------------------------------------------------------------------------------------------
  Recursively search files. Uses editor project folders and currently known file extensions

  Returns TRUE if found something, FALSE if not
-------------------------------------------------------------------------------------------------*/
bool_t NcsProjSearchFiles(sNcsFindStats_t *pStats)
{
  sNedEditor_t     *pEditor = NedEditor();
  char              szPath[PATH_MAX];
  unsigned          numFolders;
  unsigned          i;
  bool_t            fContinue = TRUE;

  // if no project folders defined, just use folder where ned.json project file is stored
  numFolders = NedListNumItems(pEditor->hProjectFolders);
  if(numFolders == 0)
  {
    numFolders = 1;
    strcpy(szPath, NedStrDirOnly(NedEditorProjPath()));
  }
  else
  {
    NedListIterStart(pEditor->hProjectFolders);
    strcpy(szPath, NedListPrev(pEditor->hProjectFolders));
  }
  i = 0;
  while(i < numFolders)
  {
    // search this file folder and all its subfolders for the search string
    // builds the results in the editor error file
    NedStrAppendName(szPath, "*");
    fContinue = NcsProjSearchRecursive(1, szPath, pStats);
    if(!fContinue)
      break;

    ++i;
    if(i < numFolders)
      strcpy(szPath, NedListPrev(pEditor->hProjectFolders));
  }

  NedLogPrintfEx(NEDLOG_CMD_EDIT, "Done NcsProjSearchFiles, numfound %ld\n", pStats->numFound);
  return pStats->numFound ? TRUE : FALSE;
}

/*!------------------------------------------------------------------------------------------------
  Set search options CAW (Case, wrAP, Whole-Word)

  @ingroup  ned_cmd
  @returns  none
*///-----------------------------------------------------------------------------------------------
void NedCmdSearchOptions(void)
{
  sNedSearch_t     *pSearch = &NedEditor()->sSearch;
  nedKey_t          aAltKeys[] = { NEDKEY_CTRL_C, NEDKEY_CTRL_A, NEDKEY_CTRL_W };
  const char       *szPrompt = "Ctrl-C = Toggles Case Sensitive, Ctrl-A wrAP, Ctrl-W Whole Word: ";
  char              sz[2];
  long              ret;
  unsigned          oldOpts;

  // indicate "in-search" so MsgLine displays [CAW]
  oldOpts = pSearch->options;
  pSearch->options |= NEDSTAT_OPT_IN_SEARCH; 

  while(1)
  {
    NedEditorUpdateStatusBar();
    *sz = '\0';
    ret = NedMsgLineEdit(sz, sizeof(sz) - 1, szPrompt, aAltKeys, NULL);
    if(ret >= 0)
    {
      break;
    }
    else if(ret == -1)
    {
      NedMsgClear();
      break;
    }
    else if(ret <= -2)
    {
      switch(aAltKeys[NedMsgLineEditIndex(ret)])
      {
        case NEDKEY_CTRL_C:
          pSearch->options ^= NEDSTAT_OPT_CASE_SENSITIVE;
        break;
        case NEDKEY_CTRL_A:
          pSearch->options ^= NEDSTAT_OPT_WRAP;
        break;
        case NEDKEY_CTRL_W:
          pSearch->options ^= NEDSTAT_OPT_WHOLE_WORD;
        break;
        default:
        break;
      }
    }
  }

  // restore old options if Esc
  if(ret == -1)
    pSearch->options = oldOpts;
  pSearch->options &= ~NEDSTAT_OPT_IN_SEARCH;
  NedMsgPrintf("Search Options: %s, %s, %s",
      (pSearch->options & NEDSTAT_OPT_CASE_SENSITIVE) ? "Case Sensitive" : "Ignore Case",
      (pSearch->options & NEDSTAT_OPT_WRAP)           ? "Wrap Search"    : "No Wrap",
      (pSearch->options & NEDSTAT_OPT_WHOLE_WORD)     ? "Whole Word"     : "Partial Word");
}

/*!------------------------------------------------------------------------------------------------
  Search project folders for a string. Creates and "error" file with links to each occurrence of
  found string. For example:

      <<<AUTOGENERATED, DO NOT EDIT>>>
      test.c:9:3: search string
      test.c:26:3: search string
      test.c:27:5: search string
      acme/hello.txt:1:1: search string

  @ingroup  ned_cmd
  @returns  none
*///-----------------------------------------------------------------------------------------------
void NedCmdSearchProject(void)
{
  sNedSearch_t     *pSearch = &NedEditor()->sSearch;
  sNedFile_t       *pFileErr;
  sNcsFindStats_t   sStats;
  char              szPath[PATH_MAX];
  long              ret;
  int               len;

  // first, check that the user wants to find the string (allows options like CaseSensitive)
  ret = NcsSearch(szProjectFind);
  if(ret <= 0)
  {
    NedMsgClear();
    return;
  }

  memset(&sStats, 0, sizeof(sStats));
  sStats.pfnNcsFind = NcsProjBuildErrLines;

  // close old error file, as we'll be replacing it
  pFileErr = NedEditorFileErr();
  if(pFileErr)
    NedEditorFileClose(pFileErr);

  // create a psuedo file in the $(HOME) folder called SEARCH.TXT
  NedLibFileFullPath(szPath, "~/SEARCH.TXT");
  pFileErr = NedFileNew(NULL, szPath);
  if(!pFileErr)
    return;

  // create error file header
  NedFileClear(pFileErr);
  pFileErr->pBufHead->id  = UINT_MAX - 3;
  NedPointInsBlock(&pFileErr->sCursor, (void *)szAutogenerated, sizeof(szAutogenerated) - 1);
  NedEditor()->pFileErr   = pFileErr;

  // build the error file from the search string and project file folders
  NcsProjSearchFiles(&sStats);

  // Searched 233 files. Found 15 occurrence(s) of 'NedError' in 11 file(s)
  szPath[0] = '\n';
  len = snprintf(&szPath[1], sizeof(szPath)-2, szNcsProjFound, sStats.numFiles, sStats.numFound, pSearch->szFind, sStats.inFiles) + 1;
  szPath[len++] = '\n';
  NedPointFileBottom(&pFileErr->sCursor);
  NedPointInsBlock(&pFileErr->sCursor, (void *)szPath, len);
  NedPointFileTop(&pFileErr->sCursor);

  // error file will be 1st file, and cursor will end up there
  pFileErr->pNext         = NedEditor()->pFileList;
  NedEditor()->pFileList  = pFileErr;
  NedEditorSetFileCur(pFileErr);
  pFileErr->fRdOnly       = TRUE;
  NedEditorSetWindowItems();
  NedEditorBuildAroundCursor();

  NedMsgPrintf(szNcsProjFound, sStats.numFiles, sStats.numFound, pSearch->szFind, sStats.inFiles);

  NedLogPrintfEx(NEDLOG_CMD_EDIT, szNcsProjFound, sStats.numFiles, sStats.numFound, pSearch->szFind, sStats.inFiles);
  NedLogPrintfEx(NEDLOG_CMD_EDIT, "\n");
}

/*-------------------------------------------------------------------------------------------------
  Used to find the definition of a function, class or struct. On entry, the symbol to look for is
  in pStat->pData.

  If found, the file will be added to the editor's file list and 

  @ingroup  ned_cmd
  @returns  FALSE (to quit) if found, TRUE if not found to continue to next file
*///-----------------------------------------------------------------------------------------------
bool_t NcsProjFindDefinition(const char *szPath, struct sNcsFindStats_tag *pStats)
{
  sNedFile_t       *pFile       = NULL;
  sNedPoint_t       sPoint;
  sNedPoint_t       sLineBeg;
  long              pos;
  bool_t            fExists     = FALSE;
  bool_t            fContinue   = TRUE;
  pfnIsFuncLine_t   pfnIsFuncLine;

  NedLogPrintfEx(NEDLOG_CMD_EDIT, "NcsProjFindDefinition(szPath=%s, symbol=%s)\n", szPath, pStats->pData);

  // load the file to search (if not already loaded)
  pFile = NedEditorFileIsOpen(szPath);
  if(pFile)
    fExists = TRUE;
  else
    pFile = NedFileNew(NULL, szPath);

  // bad path or permissions, nothing to do
  if(pFile != NULL)
  {
    // look through this file for the symbol definition (must pass isFuncLine)
    NedPointInit(&sPoint, pFile->pBufHead);
    while(1)
    {
      // not found
      if(!NedPointSearch(&sPoint, pStats->pData, NEDPT_SEARCH_OPT_CASE_SENSITIVE | NEDPT_SEARCH_OPT_WHOLE_WORD))
        break;

      NedLogPrintfEx(NEDLOG_CMD_EDIT, "Found symbol on line %ld\n", NedPointLineGet(&sPoint, NULL));
      sLineBeg = sPoint;
      NedPointLineBeg(&sLineBeg);
      pfnIsFuncLine = NedEditorGetLangFuncLine(NedFilePath(pFile));
      if((pfnIsFuncLine)(&sLineBeg))
      {
        NedLogPrintfEx(NEDLOG_CMD_EDIT, "Found Function Line, fExists %u\n", fExists);
        ++pStats->numFound;
        pos = NedPointPos(&sLineBeg);
        if(!fExists)
          NedFileFree(NULL, pFile);

        // add to editor list, Window menu, etc...
        // quirk of NedEditorFileNew(), doesn't actually change position to curPos (not a bug)
        pStats->pData = pFile = NedEditorFileNew(szPath, pos);
        if(fExists)
          NedPointFileGotoPos(&pFile->sCursor, pos);
        fContinue = FALSE;
        break;
      }
    }

    // done searching, free the file if it wasn't already open in the editor
    if(fContinue && !fExists && pFile)
        NedFileFree(NULL, pFile);
  }

  return fContinue;
}

/*!------------------------------------------------------------------------------------------------
  Very similar to search project, but rather than building a list, goes to the one that is found
  that actually a function line.

  @ingroup  ned_cmd
  @returns  none
*///-----------------------------------------------------------------------------------------------
void NedCmdMoveToDefinition(void)
{
  sNcsFindStats_t   sStats;
  long              symLen;
  uint8_t           szSymbol[NEDCFG_MAX_WIDTH];
  sNedFile_t       *pFile;

  symLen = NedPointSymbolGet(szSymbol, NedEditorCursor(), sizeof(szSymbol) - 1);
  if(symLen <= 0)
    NedMsgPrintf("Not a symbol");
  else
  {
    NedEditorAddPosHistory();
    NedLogPrintfEx(NEDLOG_CMD_EDIT, "NedCmdMoveToDefinition(%s)\n", szSymbol);
    memset(&sStats, 0, sizeof(sStats));
    sStats.pfnNcsFind = NcsProjFindDefinition;
    sStats.pData      = szSymbol;

    // search all the files for this function or struct or class
    if(NcsProjSearchFiles(&sStats))
    {
      pFile = sStats.pData;
      NedEditorGotoPoint(&pFile->sCursor);
      NedMsgPrintf("Found '%s' on line %lu", (char *)szSymbol, NedPointLineGet(&pFile->sCursor, NULL));
    }
    else
      NedMsgPrintf("Searched %ld files. Symbol '%s' not found", sStats.numFiles, (char *)szSymbol);
  }
}

/*-------------------------------------------------------------------------------------------------
  Replace strings in a file. 
-------------------------------------------------------------------------------------------------*/
static bool_t NcsProjReplace(const char *szPath, sNcsFindStats_t *pStats)
{
  sNedFile_t     *pFile;
  sNcsReplace_t  *pReplace      = pStats->pData;
  long            curPos        = 0L;
  bool_t          fAlreadyOpen  = FALSE;
  long            numReplaced;

  // nothing to do, user ESCed
  if(pReplace->fEsc)
    return TRUE;

  // preserve cursor position if the file is already open
  pFile = NedEditorFileIsOpen(szPath);
  if(pFile)
  {
    curPos = NedPointPos(&pFile->sCursor);
    fAlreadyOpen = TRUE;
  }
  else
  {
    pFile = NedEditorFileNew(szPath, 0L);
  }

  // if can't open file, then bad permissions or bad path
  if(!pFile)
    return TRUE;

  // ask user to replace yna in current file
  NedEditor()->pFileCur = pFile;
  numReplaced = pReplace->numReplaced;
  pReplace->numReplaced = 0L;
  NcsReplace(pReplace);
  if(pReplace->numReplaced)
  {
    pStats->inFiles += 1;
    NedFileSave(pFile);
    pFile->fDirty = FALSE;
  }
  pReplace->numReplaced += numReplaced;

  // if user presses ESC, stay in this file and leave it open
  if(!pReplace->fEsc)
  {
    if(!fAlreadyOpen)
      NedEditorFileClose(pFile);
    else
      NedPointFileGotoPos(&pFile->sCursor, curPos);
  }
  return TRUE;
}

/*!------------------------------------------------------------------------------------------------
  Search and replace. Replace: string with string? (yna)
  
  With: other string (y

  @ingroup  ned_cmd
  @returns  none
*///-----------------------------------------------------------------------------------------------
void NedCmdReplaceProject(void)
{
  sNedSearch_t     *pSearch = &NedEditor()->sSearch;
  sNedFile_t       *pFileCur;
  long              curPos;
  sNcsFindStats_t   sStats;
  sNcsReplace_t     sReplace;
  long              ret;

  // what string to replace it with?
  memset(&sReplace, 0, sizeof(sReplace));
  memset(&sStats,   0, sizeof(sStats));
  sStats.pfnNcsFind = NcsProjReplace;
  sStats.pData      = &sReplace;

  // what string to find?
  ret = NcsSearch(szProjectReplace);
  if(ret <= 0)
  {
    NedMsgClear();
    return;
  }

  ret = NedMsgLineEdit(pSearch->szReplace, sizeof(pSearch->szReplace) - 1, szWith, NULL, pSearch->szPaste);
  if(ret <= 0)
  {
    NedMsgPrintf(szNcsReplaced, sReplace.numReplaced);
    return;
  }

  // remember for later restoring
  NedEditorAddPosHistory();
  pFileCur = NedEditorFileCur();
  curPos   = NedPointPos(&pFileCur->sCursor);

  NcsProjSearchFiles(&sStats);

  // restore file/cursor position
  if(!sReplace.fEsc)
  {
    NedEditorSetFileCur(pFileCur);
    NedPointFileGotoPos(&pFileCur->sCursor, curPos);
    NedEditorBuildAroundCursor();
  }

  // Searched %ld files. Replaced %ld item(s) in %ld file(s)
  if(!sReplace.fFound)
    NedMsgPrintf(szNcsProjNotFound, sStats.numFiles, pSearch->szFind);
  else
    NedMsgPrintf(szNcsProjReplaced, sStats.numFiles, sReplace.numReplaced, sStats.inFiles);
}
